using Godot;

namespace Rokojori
{

  [GlobalClass]
  public partial class RJAnimatableBody3D:AnimatableBody3D
  {
  
  
  [Export]
  public RJAction OnInputEvent;
  
  [Export]
  public RJAction OnMouseEntered;
  
  [Export]
  public RJAction OnMouseExited;
  
  [Export]
  public RJAction OnVisibilityChanged;
  
  [Export]
  public RJAction OnReady;
  
  [Export]
  public RJAction OnRenamed;
  
  [Export]
  public RJAction OnTreeEntered;
  
  [Export]
  public RJAction OnTreeExiting;
  
  [Export]
  public RJAction OnTreeExited;
  
  [Export]
  public RJAction OnChildEnteredTree;
  
  [Export]
  public RJAction OnChildExitingTree;
  
  [Export]
  public RJAction OnChildOrderChanged;
  
  [Export]
  public RJAction OnReplacingBy;
  
  [Export]
  public RJAction OnEditorDescriptionChanged;
  
  [Export]
  public RJAction OnScriptChanged;
  
  [Export]
  public RJAction OnPropertyListChanged;
  
  public override void _Ready()
  {
    InputEvent += ( p0, p1, p2, p3, p4 ) => { Actions.Trigger( OnInputEvent ); }; 
    MouseEntered += (  ) => { Actions.Trigger( OnMouseEntered ); }; 
    MouseExited += (  ) => { Actions.Trigger( OnMouseExited ); }; 
    VisibilityChanged += (  ) => { Actions.Trigger( OnVisibilityChanged ); }; 
    Ready += (  ) => { Actions.Trigger( OnReady ); }; 
    Renamed += (  ) => { Actions.Trigger( OnRenamed ); }; 
    TreeEntered += (  ) => { Actions.Trigger( OnTreeEntered ); }; 
    TreeExiting += (  ) => { Actions.Trigger( OnTreeExiting ); }; 
    TreeExited += (  ) => { Actions.Trigger( OnTreeExited ); }; 
    ChildEnteredTree += ( p0 ) => { Actions.Trigger( OnChildEnteredTree ); }; 
    ChildExitingTree += ( p0 ) => { Actions.Trigger( OnChildExitingTree ); }; 
    ChildOrderChanged += (  ) => { Actions.Trigger( OnChildOrderChanged ); }; 
    ReplacingBy += ( p0 ) => { Actions.Trigger( OnReplacingBy ); }; 
    EditorDescriptionChanged += ( p0 ) => { Actions.Trigger( OnEditorDescriptionChanged ); }; 
    ScriptChanged += (  ) => { Actions.Trigger( OnScriptChanged ); }; 
    PropertyListChanged += (  ) => { Actions.Trigger( OnPropertyListChanged ); }; 
  }
  }
}
